# coding: utf-8

"""
    NCBI Datasets API

    NCBI service to query and download biological sequence data across all domains of life from NCBI databases.  # noqa: E501

    The version of the OpenAPI document: v1alpha
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ncbi.datasets.configuration import Configuration


class V1alpha1Sars2Summary(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'protein_summaries': 'dict(str, V1alpha1VirusDatasetSummary)'
    }

    attribute_map = {
        'protein_summaries': 'protein_summaries'
    }

    def __init__(self, protein_summaries=None, local_vars_configuration=None):  # noqa: E501
        """V1alpha1Sars2Summary - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._protein_summaries = None
        self.discriminator = None

        if protein_summaries is not None:
            self.protein_summaries = protein_summaries

    @property
    def protein_summaries(self):
        """Gets the protein_summaries of this V1alpha1Sars2Summary.  # noqa: E501

        Keys are the canonical protein names.  # noqa: E501

        :return: The protein_summaries of this V1alpha1Sars2Summary.  # noqa: E501
        :rtype: dict(str, V1alpha1VirusDatasetSummary)
        """
        return self._protein_summaries

    @protein_summaries.setter
    def protein_summaries(self, protein_summaries):
        """Sets the protein_summaries of this V1alpha1Sars2Summary.

        Keys are the canonical protein names.  # noqa: E501

        :param protein_summaries: The protein_summaries of this V1alpha1Sars2Summary.  # noqa: E501
        :type: dict(str, V1alpha1VirusDatasetSummary)
        """

        self._protein_summaries = protein_summaries

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1alpha1Sars2Summary):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1alpha1Sars2Summary):
            return True

        return self.to_dict() != other.to_dict()
